"use strict";
/**
 * monorepo-root
 * Find the monorepo root directory
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.monorepoRoot = void 0;
const path = __importStar(require("path"));
const find_up_1 = __importDefault(require("find-up"));
const E = __importStar(require("fp-ts/Either"));
const function_1 = require("fp-ts/function");
const err = (path) => ({
    type: 'cannot find lerna manifest upwards from known path',
    path,
});
const findup = (target, cwd) => (0, function_1.pipe)(
// FIXME: this should be async, or at least offer an async version in addition
find_up_1.default.sync(target, { cwd, type: 'file' }), E.fromNullable(err(cwd)), E.map(path.dirname));
/**
 * Find the monorepo root directory, searching upwards from `path`.
 */
function monorepoRoot(pathInsideMonorepo) {
    return (0, function_1.pipe)(E.fromNullable(err(''))(pathInsideMonorepo), E.chain((from) => findup('lerna.json', from)), E.alt(() => (0, function_1.pipe)(findup('lerna.json', process.cwd()), E.mapLeft((0, function_1.constant)(err(process.cwd()))))));
}
exports.monorepoRoot = monorepoRoot;
//# sourceMappingURL=monorepo-root.js.map